<script setup lang="ts">
import { onMounted, ref, watch } from "vue";
import type { Header, Item, ServerOptions } from "vue3-easy-data-table";
import { useFormStore } from "@/stores/forms"
import { listingTypes } from "@/stores/listingTypes";
import { useRoute, useRouter } from "vue-router"
import { toast } from "vue3-toastify";
import { useI18n } from 'vue-i18n'
const { t, locale } = useI18n()


const route = useRoute()
const router = useRouter()
const formStore = useFormStore()
const listingTypesStorage = listingTypes();

const formList = ref<object[]>([])


const loading = ref(false);
const serverItemsLength = ref(0);
const serverOptions = ref<ServerOptions>({
    page: 1,
    rowsPerPage: 5
});

const isChecked = (id: number): boolean => {
    let result = false
    formList.value.forEach(element => {
        console.log(element)

        if (element.id == id) {
            result = true

        }
    })

    return result

}

async function getListForm() {
    loading.value = true;
    await formStore.getAllFormsList({ page: serverOptions.value.page, limit: serverOptions.value.rowsPerPage })
    serverItemsLength.value = formStore.getFormsList.data.total_count
    loading.value = false;
}

onMounted(async () => {

    await getListForm()
    await listingTypesStorage.FETCH_SUBE_TYPE_RELATION_FORM_LIST({ main_id: route.query.main_id, sub_id: route.query.sub_id })
    formList.value = listingTypesStorage.getSubeTypeRelationFormList.data
    formList.value = formList.value.map(item => {
        return {
            id: item.form_id,
            main: item.main
        }
    })
})

function getId(id) {
    if (formList.value.some(item => item.id == id)) {
        let index = formList.value.map(el => el.id).indexOf(id)
        formList.value.splice(index, 1)
    } else {
        formList.value.push({
            id: id,
            main: false
        })
    }

}
const headers = [
    { text: "button", value: "check" },
    { text: "id", value: "id" },
    { text: "name", value: "name" },
    { text: "actions", value: "actions" },

];

const headerItemClassNameFunction = (header): string => {
    if (header.value === "actions") return "float-right mr-12";
    return "";
};

async function addRelationForm() {
    try {
        await listingTypesStorage.CREATE_SUB_TYPE_RELATION_FORM({
            forms: formList.value,
            main_id: route.query.main_id,
            sub_id: route.query.sub_id
        })
        toast.success("Success");
        router.push('/listing-types')
    } catch (error) {
        toast.error(error.response.data.msg ? error.response.data.msg : "Error");
    }
}

watch(
    serverOptions,
    (value) => {
        getListForm();
    },
    { deep: true }
);
</script>

<template>
    <div>
        <!-- {{ formList }} -->
        <!-- {{ listingTypesStorage.getSubeTypeRelationFormList }} -->
        <div class="flex items-center gap-2">
            <div class="w-1/4">
                <label for="search">
                    {{ t('Search') }}
                    <input id="search" type="text" class="form-input" :placeholder="t('Search')">
                </label>
            </div>

            <div class="w-1/4">
                <label for="state">
                    {{ t('State') }}
                    <v-select id="state" :options="books" label="title" class="!rounded-md mt-1"
                        :placeholder="t('State')" />
                </label>
            </div>


        </div>
        <div class="flex items-center mb-2 ">
            <button class="btn-success w-1/12 ml-auto" @click="addRelationForm">{{ t('Add') }}</button>
        </div>

        <EasyDataTable buttons-pagination v-model:server-options="serverOptions" :server-items-length="serverItemsLength"
            :loading="loading" id="user-table" :header-item-class-name="headerItemClassNameFunction" :headers="headers"
            :items="formStore.getFormsList.data.data" :rows-items="[5, 10, 15]" :rows-per-page="10">

            <template #empty-message>
                <span>{{ t('empty_text') }}</span>
            </template>

            <template #header="data">
                {{ t(data.text) }}
            </template>

            <template #item-check="item">
                <input type="checkbox" @change="getId(item.id)" :checked="isChecked(item.id)">
            </template>

            <template #item-name="item">
                {{ item.name[locale.valueOf()] }}
            </template>

            <!-- <template #item-actions="item">
                <div class="flex items-center justify-end gap-2">
                    <button class="btn-warning btn-action" @click="$router.push(`/form-detail/${item.id}`)">
                        <span uk-icon="icon: pencil" class="uk-icon"></span>
                    </button>
                    <button class="btn-danger btn-action" @click="deleteForm(item.id)">
                        <span uk-icon="icon: trash" class="uk-icon"></span>
                    </button>
                </div>
            </template> -->
        </EasyDataTable>
    </div>
</template>

<style></style>